"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Comment_1 = require("./Comment");
const ShallowUser_1 = require("./ShallowUser");
class Answer {
    constructor(answer) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
        this.accepted = (_a = answer.accepted, (_a !== null && _a !== void 0 ? _a : null));
        this.answerId = answer.answer_id;
        this.awardedBountyAmount = (_b = answer.awarded_bounty_amount, (_b !== null && _b !== void 0 ? _b : null));
        if (typeof answer.awarded_bounty_users === 'undefined') {
            this.awardedBountyUsers = null;
        }
        else {
            this.awardedBountyUsers = answer.awarded_bounty_users
                .map((shallow_user) => new ShallowUser_1.ShallowUser(shallow_user));
        }
        this.body = (_c = answer.body, (_c !== null && _c !== void 0 ? _c : null));
        this.bodyMarkdown = (_d = answer.body_markdown, (_d !== null && _d !== void 0 ? _d : null));
        this.canFlag = (_e = answer.can_flag, (_e !== null && _e !== void 0 ? _e : null));
        this.commentCount = (_f = answer.comment_count, (_f !== null && _f !== void 0 ? _f : null));
        if (typeof answer.comments === 'undefined') {
            this.comments = null;
        }
        else {
            this.comments = answer.comments
                .map((comment) => new Comment_1.Comment(comment));
        }
        this.communityOwnedDate = (_g = answer.community_owned_date, (_g !== null && _g !== void 0 ? _g : null));
        this.creationDate = answer.creation_date;
        this.downVoteCount = (_h = answer.down_vote_count, (_h !== null && _h !== void 0 ? _h : null));
        this.downvoted = (_j = answer.downvoted, (_j !== null && _j !== void 0 ? _j : null));
        this.isAccepted = answer.is_accepted;
        this.lastActivityDate = answer.last_activity_date;
        this.lastEditDate = (_k = answer.last_edit_date, (_k !== null && _k !== void 0 ? _k : null));
        if (typeof answer.last_editor === 'undefined') {
            this.lastEditor = null;
        }
        else {
            this.lastEditor = new ShallowUser_1.ShallowUser(answer.last_editor);
        }
        this.link = (_l = answer.link, (_l !== null && _l !== void 0 ? _l : null));
        this.lockedDate = (_m = answer.locked_date, (_m !== null && _m !== void 0 ? _m : null));
        if (typeof answer.owner === 'undefined') {
            this.owner = null;
        }
        else {
            this.owner = new ShallowUser_1.ShallowUser(answer.owner);
        }
        this.questionId = answer.question_id;
        this.score = answer.score;
        this.shareLink = (_o = answer.share_link, (_o !== null && _o !== void 0 ? _o : null));
        this.tags = (_p = answer.tags, (_p !== null && _p !== void 0 ? _p : null));
        this.title = (_q = answer.title, (_q !== null && _q !== void 0 ? _q : null));
        this.upVoteCount = (_r = answer.up_vote_count, (_r !== null && _r !== void 0 ? _r : null));
        this.upvoted = (_s = answer.upvoted, (_s !== null && _s !== void 0 ? _s : null));
    }
}
exports.Answer = Answer;
