"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Site_1 = require("./Site");
class Info {
    constructor(info) {
        this.answersPerMinute = info.answers_per_minute;
        this.apiRevision = info.api_revision;
        this.badgesPerMinute = info.badges_per_minute;
        this.newActiveUsers = info.new_active_users;
        this.questionsPerMinute = info.questions_per_minute;
        if (typeof info.site === 'undefined') {
            this.site = null;
        }
        else {
            this.site = new Site_1.Site(info.site);
        }
        this.totalAccepted = info.total_accepted;
        this.totalAnswers = info.total_answers;
        this.totalBadges = info.total_badges;
        this.totalComments = info.total_comments;
        this.totalQuestions = info.total_questions;
        this.totalUnanswered = info.total_unanswered;
        this.totalUsers = info.total_users;
        this.totalVotes = info.total_votes;
    }
}
exports.Info = Info;
