import { Wrapper } from '../objects/Wrapper';
import { Answer } from './Answer';
import { Badge } from './Badge';
import { Comment } from './Comment';
import { Info } from './Info';
import { Privilege } from './Privilege';
import { Question } from './Question';
import { Site } from './Site';
import { Tag } from './Tag';
import { AdvancedSearchOptions } from '../method-options/StackExchange/AdvancedSearchOptions';
import { GetAnswersOptions } from '../method-options/StackExchange/GetAnswersOptions';
import { GetAnswersByIdsOptions } from '../method-options/StackExchange/GetAnswersByIdsOptions';
import { GetBadgesOptions } from '../method-options/StackExchange/GetBadgesOptions';
import { GetBadgesByIdsOptions } from '../method-options/StackExchange/GetBadgesByIdsOptions';
import { GetCommentsOptions } from '../method-options/StackExchange/GetCommentsOptions';
import { GetCommentsByIdsOptions } from '../method-options/StackExchange/GetCommentsByIdsOptions';
import { GetCommentsOnAnswersOptions } from '../method-options/StackExchange/GetCommentsOnAnswersOptions';
import { GetInfoOptions } from '../method-options/StackExchange/GetInfoOptions';
import { GetNamedOrTagBasedBadgesOptions } from '../method-options/StackExchange/GetNamedOrTagBasedBadgesOptions';
import { GetPrivilegesOptions } from '../method-options/StackExchange/GetPrivilegesOptions';
import { GetRecipientsBadgesOptions } from '../method-options/StackExchange/GetRecipientsBadgesOptions';
import { GetRecipientsBadgesByIdsOptions } from '../method-options/StackExchange/GetRecipientsBadgesByIdsOptions';
import { GetSitesOptions } from '../method-options/StackExchange/GetSitesOptions';
import { GetTagsOptions } from '../method-options/StackExchange/GetTagsOptions';
import { SearchOptions } from '../method-options/StackExchange/SearchOptions';
import { SimilarSearchOptions } from '../method-options/StackExchange/SimilarSearchOptions';
export declare class StackExchange {
    protected static baseUrl: URL;
    protected static dateHandler(date: Date): string;
    protected static semiDelimitedListHandler(list: string[] | string): string;
    static advancedSearch(options: AdvancedSearchOptions): Promise<Wrapper<Question>>;
    static getAnswers(options: GetAnswersOptions): Promise<Wrapper<Answer>>;
    static getAnswersByIds(options: GetAnswersByIdsOptions): Promise<Wrapper<Answer>>;
    static getBadges(options: GetBadgesOptions): Promise<Wrapper<Badge>>;
    static getBadgesByIds(options: GetBadgesByIdsOptions): Promise<Wrapper<Badge>>;
    static getNamedBadges(options: GetNamedOrTagBasedBadgesOptions): Promise<Wrapper<Badge>>;
    static getTagBasedBadges(options: GetNamedOrTagBasedBadgesOptions): Promise<Wrapper<Badge>>;
    static getRecipientsBadges(options: GetRecipientsBadgesOptions): Promise<Wrapper<Badge>>;
    static getRecipientsBadgesByIds(options: GetRecipientsBadgesByIdsOptions): Promise<Wrapper<Badge>>;
    static getComments(options: GetCommentsOptions): Promise<Wrapper<Comment>>;
    static getCommentsByIds(options: GetCommentsByIdsOptions): Promise<Wrapper<Comment>>;
    static getCommentsOnAnswers(options: GetCommentsOnAnswersOptions): Promise<Wrapper<Comment>>;
    static getInfo(options: GetInfoOptions): Promise<Wrapper<Info>>;
    static getPrivileges(options: GetPrivilegesOptions): Promise<Wrapper<Privilege>>;
    static getSites(options: GetSitesOptions): Promise<Wrapper<Site>>;
    static getTags(options: GetTagsOptions): Promise<Wrapper<Tag>>;
    static getModeratorOnlyTags(options: Omit<GetTagsOptions, 'moderatorOnly' | 'required'>): Promise<Wrapper<Tag>>;
    static getRequiredTags(options: Omit<GetTagsOptions, 'moderatorOnly' | 'required'>): Promise<Wrapper<Tag>>;
    static search(options: SearchOptions): Promise<Wrapper<Question>>;
    static similarSearch(options: SimilarSearchOptions): Promise<Wrapper<Question>>;
}
