import { Answer } from './Answer';
import { Badge } from './Badge';
import { Comment } from './Comment';
import { Info } from './Info';
import { Privilege } from './Privilege';
import { Question } from './Question';
import { Site } from './Site';
import { Tag } from './Tag';
import { TypeWrapper } from '../result-types/TypeWrapper';
declare type ClassType = 'Answer' | 'Badge' | 'Comment' | 'Info' | 'Privilege' | 'Question' | 'Site' | 'Tag';
export declare class Wrapper<T extends Answer | Badge | Comment | Info | Privilege | Question | Site | Tag> {
    backoff?: number;
    errorId?: number;
    errorMessage?: string;
    errorName?: string;
    hasMore: boolean;
    items: T[];
    page?: number;
    pageSize?: number;
    quotaMax: number;
    quotaRemaining: number;
    total?: number;
    type?: string;
    constructor(wrapper: TypeWrapper, classType: ClassType);
}
export {};
