"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Answer_1 = require("./Answer");
const Badge_1 = require("./Badge");
const Comment_1 = require("./Comment");
const Info_1 = require("./Info");
const Privilege_1 = require("./Privilege");
const Question_1 = require("./Question");
const Site_1 = require("./Site");
const Tag_1 = require("./Tag");
class Wrapper {
    constructor(wrapper, classType) {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        this.backoff = (_a = wrapper.backoff, (_a !== null && _a !== void 0 ? _a : null));
        this.errorId = (_b = wrapper.error_id, (_b !== null && _b !== void 0 ? _b : null));
        this.errorMessage = (_c = wrapper.error_message, (_c !== null && _c !== void 0 ? _c : null));
        this.errorName = (_d = wrapper.error_name, (_d !== null && _d !== void 0 ? _d : null));
        this.hasMore = wrapper.has_more;
        switch (classType) {
            case 'Answer':
                this.items
                    = [...wrapper.items]
                        .map((item) => new Answer_1.Answer(item));
                break;
            case 'Badge':
                this.items
                    = [...wrapper.items]
                        .map((item) => new Badge_1.Badge(item));
                break;
            case 'Comment':
                this.items
                    = [...wrapper.items]
                        .map((item) => new Comment_1.Comment(item));
                break;
            case 'Info':
                this.items
                    = [...wrapper.items]
                        .map((item) => new Info_1.Info(item));
                break;
            case 'Privilege':
                this.items
                    = [...wrapper.items]
                        .map((item) => new Privilege_1.Privilege(item));
                break;
            case 'Question':
                this.items
                    = [...wrapper.items]
                        .map((item) => new Question_1.Question(item));
                break;
            case 'Site':
                this.items
                    = [...wrapper.items]
                        .map((item) => new Site_1.Site(item));
                break;
            case 'Tag':
                this.items
                    = [...wrapper.items]
                        .map((item) => new Tag_1.Tag(item));
                break;
            default:
                this.items = null;
        }
        this.page = (_e = wrapper.page, (_e !== null && _e !== void 0 ? _e : null));
        this.pageSize = (_f = wrapper.page_size, (_f !== null && _f !== void 0 ? _f : null));
        this.quotaMax = wrapper.quota_max;
        this.quotaRemaining = wrapper.quota_remaining;
        this.total = (_g = wrapper.total, (_g !== null && _g !== void 0 ? _g : null));
        this.type = (_h = wrapper.type, (_h !== null && _h !== void 0 ? _h : null));
    }
}
exports.Wrapper = Wrapper;
